package netrexx.lang;

import java.io.PrintStream;

public final class RexxTrace {
   public static final int OFF = 0;
   public static final int VAR = 1;
   public static final int METHODS = 2;
   public static final int ALL = 3;
   public static final int RESULTS = 4;
   public static final int TERMS = 5;
   public static final int OPS = 6;
   private static final Rexx levelwords = new Rexx("off var methods all results terms operations");
   private static final String nulltrace = "[null]";
   private int level;
   private int width;
   private int lastline;
   private PrintStream tracestream;
   private static final Rexx $$4 = new Rexx("*-*");
   private static final Rexx $$6 = new Rexx("");
   // $FF: renamed from: $0 java.lang.String
   private static final String field_0 = "RexxTrace.nrx";

   public RexxTrace(int var1) {
      this(var1, System.err);
   }

   public RexxTrace(int var1, PrintStream var2) {
      this.width = String.valueOf(var1).length();
      this.tracestream = var2;
   }

   public RexxTrace(RexxTrace var1) {
      this(0);
      this.level = var1.level;
      this.width = var1.width;
      this.lastline = var1.lastline;
      this.tracestream = var1.tracestream;
   }

   public Rexx levelword() {
      return levelwords.word(new Rexx(this.level + 1));
   }

   public void newlevel(int var1) {
      this.level = var1;
      if (this.level == 0) {
         this.lastline = 0;
      }

   }

   public void traceclause(int var1, String[] var2) {
      this.traceclause(var1, var2, 3);
   }

   public void traceclause(int var1, String[] var2, int var3) {
      Object var4 = null;
      boolean var5 = false;
      if (this.level >= var3) {
         Rexx var7;
         if (this.lastline == var1) {
            var7 = (new Rexx(' ')).copies(new Rexx(this.width));
         } else {
            var7 = (new Rexx(var1)).right(new Rexx(this.width));
            this.lastline = var1 + var2.length - 1;
         }

         var7 = var7.OpCcblank((RexxSet)null, new Rexx("*=*"));
         int var6 = var2.length - 1;

         for(int var9 = 0; var9 <= var6; ++var9) {
            this.tracestream.println((new Rexx(' ')).OpCc((RexxSet)null, var7).OpCcblank((RexxSet)null, new Rexx(var2[var9])));
            var7 = (new Rexx(var1 + var9 + 1)).right(new Rexx(this.width)).OpCcblank((RexxSet)null, $$4);
         }

      }
   }

   private void tracedata(int var1, Rexx var2, char var3, String var4) {
      Object var5 = null;
      Object var6 = null;
      boolean var7 = false;
      Rexx var9;
      if (this.lastline == var1) {
         var9 = (new Rexx(' ')).copies(new Rexx(this.width));
      } else {
         var9 = (new Rexx(var1)).right(new Rexx(this.width));
         this.lastline = var1;
      }

      var9 = var9.OpCcblank((RexxSet)null, new Rexx('>')).OpCc((RexxSet)null, new Rexx(var3)).OpCc((RexxSet)null, new Rexx('>'));
      if ((new Rexx(var4)).OpNotEq((RexxSet)null, $$6)) {
         var9 = var9.OpCcblank((RexxSet)null, new Rexx(var4));
      }

      if (var2 == null) {
         this.tracestream.println((new Rexx(' ')).OpCc((RexxSet)null, var9).OpCcblank((RexxSet)null, new Rexx("[null]")));
      } else {
         char[] var11 = var2.toCharArray();
         int var8 = var11.length - 1;

         for(int var12 = 0; var12 <= var8; ++var12) {
            if (var11[var12] < ' ') {
               if (var11[var12] == '\t') {
                  var11[var12] = ' ';
               } else {
                  var11[var12] = '?';
               }
            }
         }

         this.tracestream.println((new Rexx(' ')).OpCc((RexxSet)null, var9).OpCcblank((RexxSet)null, new Rexx('"')).OpCc((RexxSet)null, new Rexx(var11)).OpCc((RexxSet)null, new Rexx('"')));
      }
   }

   public char tracechar(int var1, char var2, char var3, int var4, String var5) {
      if (this.level >= var4) {
         this.tracedata(var1, new Rexx(var2), var3, var5);
      }

      return var2;
   }

   public boolean traceboolean(int var1, boolean var2, char var3, int var4, String var5) {
      if (this.level >= var4) {
         this.tracedata(var1, new Rexx(var2), var3, var5);
      }

      return var2;
   }

   public byte tracebyte(int var1, byte var2, char var3, int var4, String var5) {
      if (this.level >= var4) {
         this.tracedata(var1, new Rexx(var2), var3, var5);
      }

      return var2;
   }

   public short traceshort(int var1, short var2, char var3, int var4, String var5) {
      if (this.level >= var4) {
         this.tracedata(var1, new Rexx(var2), var3, var5);
      }

      return var2;
   }

   public int traceint(int var1, int var2, char var3, int var4, String var5) {
      if (this.level >= var4) {
         this.tracedata(var1, new Rexx(var2), var3, var5);
      }

      return var2;
   }

   public long tracelong(int var1, long var2, char var4, int var5, String var6) {
      if (this.level >= var5) {
         this.tracedata(var1, new Rexx(var2), var4, var6);
      }

      return var2;
   }

   public float tracefloat(int var1, float var2, char var3, int var4, String var5) {
      if (this.level >= var4) {
         this.tracedata(var1, new Rexx(var2), var3, var5);
      }

      return var2;
   }

   public double tracedouble(int var1, double var2, char var4, int var5, String var6) {
      if (this.level >= var5) {
         this.tracedata(var1, new Rexx(var2), var4, var6);
      }

      return var2;
   }

   public Rexx traceRexx(int var1, Rexx var2, char var3, int var4, String var5) {
      if (this.level >= var4) {
         this.tracedata(var1, var2, var3, var5);
      }

      return var2;
   }

   public String traceString(int var1, String var2, char var3, int var4, String var5) {
      if (this.level < var4) {
         return var2;
      } else {
         if (var2 == null) {
            this.tracedata(var1, (Rexx)null, var3, var5);
         } else {
            this.tracedata(var1, new Rexx(var2), var3, var5);
         }

         return var2;
      }
   }

   public char[] tracechararray(int var1, char[] var2, char var3, int var4, String var5) {
      if (this.level < var4) {
         return var2;
      } else {
         if (var2 == null) {
            this.tracedata(var1, (Rexx)null, var3, var5);
         } else {
            this.tracedata(var1, new Rexx(var2), var3, var5);
         }

         return var2;
      }
   }

   public Object traceObject(int var1, Object var2, char var3, int var4, String var5) {
      if (this.level < var4) {
         return var2;
      } else {
         if (var2 == null) {
            this.tracedata(var1, (Rexx)null, var3, var5);
         } else {
            this.tracedata(var1, new Rexx(var2.toString()), var3, var5);
         }

         return var2;
      }
   }
}
